if [ -n "$CI_REGISTRY_IMAGE" ] ; then
    REGISTRY=$CI_REGISTRY_IMAGE
else
    REGISTRY=gitlab.cs.hs-rm.de:4567/sls/subato2
fi

echo "Registry = $REGISTRY"

IMAGE="${REGISTRY}/subato2"
TAG="${SUBATO2_VER}"
echo "Building image $IMAGE:$TAG..."
docker build -t "$IMAGE:$TAG" subato --build-arg HTTP_PROXY=$http_proxy
docker tag ${IMAGE}:${TAG} ${IMAGE}:latest
echo "Pushing image $IMAGE:$TAG..."
docker push "$IMAGE:$TAG"
docker push "$IMAGE:latest"

if [ "$1" = "prod" ] ; then
    docker tag ${IMAGE}:${TAG} ${IMAGE}/prod:${TAG}
    docker tag ${IMAGE}:${TAG} ${IMAGE}/prod:latest
    docker push "$IMAGE/prod:$TAG"
    docker push "$IMAGE/prod:latest"

    IMAGE="${REGISTRY}/subato2/prod"
    TAG="${SUBATO2_VER}"
    echo "Building image $IMAGE:$TAG..."
    docker build -t "$IMAGE:$TAG" subato --build-arg HTTP_PROXY=$http_proxy
    docker tag ${IMAGE}:${TAG} ${IMAGE}:latest
    echo "Pushing image $IMAGE:$TAG..."
    docker push "$IMAGE:$TAG"
    docker push "$IMAGE:latest"

    IMAGE="${REGISTRY}/subato2-web/prod"
    TAG="${SUBATO2_VER}"
    echo "Building image $IMAGE:$TAG..."
    docker build -t "$IMAGE:$TAG" subato-web --build-arg HTTP_PROXY=$http_proxy --build-arg build_param=build:prod --target prod
    docker tag ${IMAGE}:${TAG} ${IMAGE}:latest
    echo "Pushing image $IMAGE:$TAG..."
    docker push "$IMAGE:$TAG"
    docker push "$IMAGE:latest"
else
    docker tag ${IMAGE}:${TAG} ${IMAGE}/test:${TAG}
    docker tag ${IMAGE}:${TAG} ${IMAGE}/test:latest
    docker push "$IMAGE/test:$TAG"
    docker push "$IMAGE/test:latest"

    IMAGE="${REGISTRY}/subato2-web/test"
    TAG="${SUBATO2_VER}"
    echo "Building image $IMAGE:$TAG..."
    docker build -t "$IMAGE:$TAG" subato-web --build-arg HTTP_PROXY=$http_proxy --build-arg build_param=build:test --target default
    docker tag ${IMAGE}:${TAG} ${IMAGE}:latest
    echo "Pushing image $IMAGE:$TAG..."
    docker push "$IMAGE:$TAG"
    docker push "$IMAGE:latest"
fi