# Keycloak Synchronisation
Damit Benutzer aus dem HDS mit eigenen Datensätzen aus Subato verknüpft werden können, werden diese in unsere Datenbank
übernommen. Die Anbindung an das HDS und der eigentliche Login erfolgt durch Keycloak, in Subato werden bei eingehenden Anfragen die
Daten aus dem Token extrahiert und in der Datenbank gespeichert. Aus Gründen der Performance wird ein Cache verwendet, sodass nicht bei jeder Anfrage eine (sonst unnötige) Aktualisierung der Datenbank erfolgt.  
Die Tabellen `user` und `user_roles` sind als Kopie zu sehen. Änderungen in den Benutzerdaten (wie z.B. Korrektur von Rollen) sollten daher immer in Keycloak erfolgen, nie in der Datenbank von Subato.

In Subato befinden sich aufgrund des beschriebenen Imports nur Benutzer, die sich entweder einmal angemeldet haben oder im Rahmen des AoR Imports angelegt wurden.

Die Berechtigungsverwaltung innerhalb von Kursen wird nicht über Keycloak abgebildet. Diese könnte zwar
theoretisch über Keycloak abgebildet werden, allerdings hat sich Keycloak bisher als sehr langsam und teilweise als unzuverlässig erwiesen.
Aus diesem Grund hat Subato die Hoheit über diese Berechtigungsdaten.

Weitere Details zu Keycloak finden sich in der [Infrastruktur-Dokumentation](https://gitlab.cs.hs-rm.de/sls/core).