# Konfiguration

## Datenbank
Konfiguration über:
- `$SUBATO2_DB_HOST`
- `$SUBATO2_DB_PORT`
- `$SUBATO2_DB_USER`
- `$SUBATO2_DB_PASSWORD`

## Datenverzeichnis
Der Pfad zum [subato2-data](persistence.md#subato2-data) Verzeichnis kann über `$SUBATO2_DATA_DIR` konfiguriert werden.

## Git-Synchronisation von Aufgaben-Pools
Aktivierung/Deaktivierung der automatischen Synchronisation über `$SUBATO2_TASK_POOL_SYNC_ENABLED`. 
Die Synchronisation erfolgt dann automatisch um 3 Uhr jeden Tag. 

Zugangsdaten des Git-Benutzers konfigurierbar über:
- `$SUBATO2_TASK_POOL_SYNC_GIT_USER`
- `$SUBATO2_TASK_POOL_SYNC_GIT_TOKEN`

## Keycloak
URL zum Keycloak Server über `$SUBATO2_KEYCLOAK_URL` setzen. 

:::caution
Es muss ein Realm `SLS` und einen Client mit dem Namen `subato-backend` geben.
:::

## Eva
Das [Eva](/eva)-System kann über 
- `$SUBATO2_EVALUATOR_URL`
- `$SUBATO2_EVALUATOR_PORT`
- `$SUBATO2_EVALUATOR_REGISTRY_PORT`
- `$SUBATO2_EVALUATOR_TIMEOUT`

konfiguriert werden.

## Seeding
Für die Initialisierung der Datenbank mit Daten aus einem anderen System kann die [Importschnittstelle](seeding.md) verwendet werden.

## Automatische Ergänzung von Kursen nach Erstellung
An der Hochschule RheinMain nutzen wir das AoR-System um Veranstaltungen zu Kursen automatisch zu importieren, sobald diese erstellt werden. Sollen nach Erstellung eines Kurses Daten (wie z.B. Veranstaltungen) automatisch aus einer eigenen Datenquelle importiert werden, kann die Schnittstelle `CourseSupplement` implementiert werden. In den JavaDocs zur Schnittstelle `CourseSupplement` finden sich weitere Informationen, als Orientierung kann die bestehende `AoRCourseSupplement` Implementierung genutzt werden. 

## Automatischer Cleanup von anonymen Lösungen
Aktivierung über `$SUBATO2_SOLUTION_CLEANUP_ENABLED`. Cleanup erfolgt alle 5 Minuten.

## Uploadlimit
Der Dateiupload wird durch ein Limit begrenzt, das mit `$SUBATO2_MAX_UPLOAD_SIZE` konfiguriert werden kann. Die Einstellung muss im Format `<Größe><Einheit>` erfolgen, also z.B. `30MB`. Das Limit wird automatisch über den `/config` HTTP Endpunkt an das Frontend kommuniziert und dort angezeigt.

:::caution Proxy-Konfiguration
Wenn das Backend über HTTP Proxies angesprochen wird, muss darauf geachtet werden, dass die Konfiguration der Proxies **mindestens** dem konfigurierte Limit entspricht. Ebenfalls ist zu beachten, dass evtl. keine trifftige Fehlermeldung im Frontend angezeigt wird, wenn die Proxies ein `413 Content Too Large` Response zurückgeben.     
:::

## Ausnahmeregeln für Mime-Type Erkennung
Für die korrekte Anzeige von Dateien im Frontend (Syntax-Highlighting, Einrückung) und für die Bestimmung von gültigen Lösungen (Quelldatei oder Binärdatei abgegeben?) ist eine Bestimmung des Mime-Types anhand des Dateinamens notwendig.

Da eine automatische Erkennung aufgrund des Wildwuchses an definierten Mime Types nicht immer korrekt erfolgt, ist es eventuell notwendig, Ausnahmen zu definieren. Die Ausnahmen werden standardmäßig über die Konfigurationsdatei `config/mime.yml` gepflegt, der Pfad zur Datei kann mit `$SUBATO2_MIME_FILE` geändert werden.
