import { Directive, ElementRef } from "@angular/core";
import { NbMenuService, NbSidebarService } from "@nebular/theme";
import { flatMap, take } from 'rxjs/operators';

@Directive({
    selector: "[sidebarHideOnClick]",
    exportAs: "sidebarHideOnClick"
})
export class SidebarHideOnClickDirective {
    constructor(
        private el: ElementRef,
        private menuService: NbMenuService,
        private sidebarService: NbSidebarService
    ) {
        this.menuService.onItemClick()
            .pipe(
                flatMap(() => this.sidebarService.getSidebarResponsiveState().pipe(take(1))),
            )
            .subscribe(state => {
                if (state != 'pc') {
                    this.sidebarService.collapse();
                }
            });
    }
}