import { ExerciseProgress } from "./exercise-progress";
import { SubmissionsProgress } from "./submissions-progress";

export class ExerciseProgressResult {
    exerciseProgresses: ExerciseProgress[];
    submissionsProgress: SubmissionsProgress;
    exercisesBinaryTotal: number;
    exercisesTotal: number;
    testsTotal: number;
    testsPassedTotal: number;
    reachedPointsTotal: number;
    reachablePointsTotal: number;
    styleErrorsTotal: number;
    leaksTotal: number;

    constructor(result: any) {
        this.exerciseProgresses = result.exerciseProgresses.map(p => new ExerciseProgress(p));
        this.submissionsProgress = new SubmissionsProgress(result.submissionsProgress);
        this.exercisesBinaryTotal = result.exercisesBinaryTotal;
        this.exercisesTotal = result.exercisesTotal;
        this.testsTotal = result.testsTotal;
        this.testsPassedTotal = result.testsPassedTotal;
        this.reachedPointsTotal = result.reachedPointsTotal;
        this.reachablePointsTotal = result.reachablePointsTotal;
        this.styleErrorsTotal = result.styleErrorsTotal;
        this.leaksTotal = result.leaksTotal;
    }
}