import { Submission } from "./submission";

export class SubmissionsProgress {
    passedTotal: number;
    notPassedTotal: number;
    undecidedTotal: number;
    total: number;
    fullyRatedTotal: number;

    constructor(dto: any) {
        this.passedTotal = dto.passedTotal;
        this.notPassedTotal = dto.notPassedTotal;
        this.undecidedTotal = dto.undecidedTotal;
        this.total = dto.total;
        this.fullyRatedTotal = dto.fullyRatedTotal;
    }

    update(submissions: Submission[]): SubmissionsProgress {
        return new SubmissionsProgress({
            passedTotal: submissions.filter(s => s.passed == true).length,
            notPassedTotal: submissions.filter(s => s.passed == false).length,
            undecidedTotal: submissions.filter(s => s.passed == null).length,
            total: submissions.length,
            fullyRatedTotal: submissions.filter(s => s.exercise.taskInstancesCount == s.pointRatingCount).length
        });
    }

    get progress() {
        return this.totalBinary != 0 ? this.decided / this.totalBinary * 100 : 100;
    }

    get progressPoints() {
        return this.total != 0 ? this.fullyRatedTotal / this.total * 100 : 100;
    }

    get totalBinary() {
        return this.notPassedTotal + this.passedTotal + this.undecidedTotal;
    }

    get decided() {
        return this.totalBinary - this.undecidedTotal;
    }
}