import { Task } from "app/features/tasks/models/task";
import { Exercise } from "./exercise";

export class TaskInstance {
    task: Task;
    orderNumber: number;
    reachablePoints?: number;
    exercise: Exercise;
    solutionPublic: boolean;
    
    constructor(taskInstance: any) {
        this.orderNumber = taskInstance.orderNumber;
        this.reachablePoints = taskInstance.reachablePoints;
        this.task = new Task(taskInstance.task);
        this.exercise = taskInstance.exercise ? new Exercise(taskInstance.exercise) : null;
        this.solutionPublic = taskInstance.solutionPublic;
    }

    hasPoints() {
        return this.reachablePoints != null;
    }

    getNextTaskInstance(taskInstances: TaskInstance[]): TaskInstance | null {
        let idx = taskInstances.map(ti => ti.task.id).indexOf(this.task.id) + 1;
        return idx < taskInstances.length ? taskInstances[idx] : null;
    }

    getPrevTaskInstance(taskInstances: TaskInstance[]): TaskInstance | null {
        let idx = taskInstances.map(ti => ti.task.id).indexOf(this.task.id) - 1;
        return idx >= 0 ? taskInstances[idx] : null;
    }
}