import { User } from "app/core/models/user";
import { Item } from "./item";

export class CourseParticipantItem extends Item {
    user: User;
    courseId: number;

    constructor(item: any, searchResult: any) {
        super(item, searchResult);
        this.user = new User(item.user);
        this.courseId = item.courseId;
    }

    url(): string {
        return `/course/${this.courseId}/progress/${this.user.id}`;
    }

    title(): string {
        return this.user.fixedName;
    }

    subtitle(): string {
        return this.user.program?.fullName ?? 'Teilnehmer';
    }
}