package de.hsrm.sls.subato.aor.term.persistence;

import de.hsrm.sls.subato.aor.term.model.TermData;
import de.hsrm.sls.subato.modules.term.Term;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

@Service
public class TermDataImportService {
    @Autowired
    TermDataImportRepository termDataImportRepository;

    public TermDataImport getTermData(Term term) {
        return termDataImportRepository.findFirstByTermIdOrderByImportedAtDesc(term.getId()).orElse(null);
    }

    public void storeImport(Term term, TermData termData) {
        var termDataImport = new TermDataImport();
        termDataImport.setTerm(term);
        termDataImport.setTermData(termData);
        termDataImport.setImportedAt(LocalDateTime.now());
        termDataImportRepository.save(termDataImport);
    }
}
