package de.hsrm.sls.subato.auth;

import de.hsrm.sls.subato.auth.principal.SubatoPrincipal;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.convert.converter.Converter;
import org.springframework.security.authentication.AbstractAuthenticationToken;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.oauth2.jwt.Jwt;
import org.springframework.stereotype.Component;

@Component
public class JwtAuthConverter implements Converter<Jwt, AbstractAuthenticationToken> {
    @Autowired
    private KeycloakLoginHandler loginHandler;

    @Override
    public AbstractAuthenticationToken convert(Jwt jwt) {
        SubatoPrincipal principal = loginHandler.handleToken(jwt);
        return new UsernamePasswordAuthenticationToken(principal, jwt, principal.getAuthorities());
        //return new JwtAuthenticationToken(jwt, authorities, getPrincipalClaimName(jwt));
    }
}