package de.hsrm.sls.subato.auth.policy.exercises;

import de.hsrm.sls.subato.auth.policy.CheckPolicyRequest;
import de.hsrm.sls.subato.auth.policy.PolicyRule;
import de.hsrm.sls.subato.courses.course.Course;
import de.hsrm.sls.subato.courses.membership.StaffGroup;
import org.springframework.stereotype.Component;

/**
 * The current user is allowed to create an exercise within a certain course
 */
@Component
public class ExerciseCreatePolicy implements PolicyRule {
    @Override
    public boolean check(CheckPolicyRequest request) {
        if(!request.matches(ExercisesAction.EXERCISE_CREATE)) {
            return false;
        }

        var course = (Course) request.getObj();
        return !request.unauthenticated() && request.getSubject().hasGroup(course.getId(), StaffGroup.ADMIN);
    }
}
