package de.hsrm.sls.subato.auth.policy.solutions;

import de.hsrm.sls.subato.auth.policy.CheckPolicyRequest;
import de.hsrm.sls.subato.auth.policy.PolicyRule;
import de.hsrm.sls.subato.solutions.solution.Solution;
import org.springframework.stereotype.Component;

/**
 * The current user is allowed to create a comment for a certain solution
 */
@Component
public class SolutionCommentCreatePolicy implements PolicyRule {
    @Override
    public boolean check(CheckPolicyRequest request) {
        if(!request.matches(SolutionsAction.SOLUTION_COMMENT_CREATE) || request.unauthenticated()) {
            return false;
        }

        var solution = (Solution) request.getObj();
        var course = solution.getExercise().getCourse();
        return solution.getSubmittedBy().getId() == request.getSubject().getId() || request.getSubject().hasAnyGroup(course.getId());
    }
}
