package de.hsrm.sls.subato.courses.unit;

import de.hsrm.sls.subato.courses.membership.CourseStaffMembershipAddedEvent;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationListener;
import org.springframework.stereotype.Component;

@Component
public class CourseStaffMembershipAddedListener implements ApplicationListener<CourseStaffMembershipAddedEvent> {
    @Autowired
    CourseUnitService courseUnitService;

    @Override
    public void onApplicationEvent(CourseStaffMembershipAddedEvent event) {
        var course = event.getMembership().getCourse();
        var user = event.getMembership().getUser();

        var sandboxUnit = course.getSandbox();
        if(!courseUnitService.isParticipant(sandboxUnit, user)) {
            courseUnitService.addParticipant(sandboxUnit, user);
        }
    }
}
