package de.hsrm.sls.subato.exercises.exercise.progress;

import de.hsrm.sls.subato.exercises.exercise.AssessmentMode;
import de.hsrm.sls.subato.exercises.submission.progress.SubmissionsProgress;

import java.util.List;

public class ExerciseProgressResult {
    private List<ExerciseProgress> exerciseProgresses;
    private SubmissionsProgress submissionsProgress;

    public ExerciseProgressResult(List<ExerciseProgress> exerciseProgresses, SubmissionsProgress submissionsProgress) {
        this.exerciseProgresses = exerciseProgresses;
        this.submissionsProgress = submissionsProgress;
    }

    public List<ExerciseProgress> getExerciseProgresses() {
        return exerciseProgresses;
    }

    public void setExerciseProgresses(List<ExerciseProgress> exerciseProgresses) {
        this.exerciseProgresses = exerciseProgresses;
    }

    public SubmissionsProgress getSubmissionsProgress() {
        return submissionsProgress;
    }

    public void setSubmissionsProgress(SubmissionsProgress submissionsProgress) {
        this.submissionsProgress = submissionsProgress;
    }

    public long getExercisesTotal() {
        return exerciseProgresses.stream().count();
    }

    public long getExercisesBinaryTotal() {
        return exerciseProgresses.stream().filter(e -> e.getExercise().getAssessmentMode() == AssessmentMode.Binary).count();
    }

    public long getReachedPointsTotal() {
        return exerciseProgresses.stream()
                .filter(e -> e.getSubmission() != null)
                .map(e -> e.getSubmission().getTotalPoints())
                .reduce(0, (sum, c) -> sum + c);
    }

    public long getReachablePointsTotal() {
        return exerciseProgresses.stream()
                .map(e -> e.getExercise().getReachablePoints())
                .reduce(0, (sum, c) -> sum + c);
    }

    public long getTestsPassedTotal() {
        return exerciseProgresses.stream().map(e -> e.getTestsPassed()).reduce(0, (sum, c) -> sum + c);
    }

    public long getTestsTotal() {
        return exerciseProgresses.stream().map(e -> e.getTestsTotal()).reduce(0, (sum, c) -> sum + c);
    }

    public long getStyleErrorsTotal() {
        return exerciseProgresses.stream().map(e -> e.getStyleErrorsTotal()).reduce(0, (sum, c) -> sum + c);
    }

    public long getLeaksTotal() {
        return exerciseProgresses.stream().map(e -> e.getLeaksTotal()).reduce(0, (sum, c) -> sum + c);
    }
}
