package de.hsrm.sls.subato.shared;

/**
 * if the change requested by an user has dangerous consequences and should be explicity confirmed by the user.
 */
public class DangerousActionException extends RuntimeException {
    public static final String REASON = "Die ausgeführte Aktion hat schwere Folgen und muss explizit bestätigt werden";

    /**
     * description of the consequences
     */
    private String description;

    /**
     * suggestion for the user, what would be a better solution
     */
    private String suggestion;

    public DangerousActionException(String description, String suggestion) {
        this.description = description;
        this.suggestion = suggestion;
    }

    public String getDescription() {
        return description;
    }

    public String getSuggestion() {
        return suggestion;
    }
}
