package de.hsrm.sls.subato.shared;

import org.springframework.beans.factory.config.YamlPropertiesFactoryBean;
import org.springframework.core.env.PropertiesPropertySource;
import org.springframework.core.env.PropertySource;
import org.springframework.core.io.support.EncodedResource;
import org.springframework.core.io.support.PropertySourceFactory;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

public class YamlPropertySourceFactory implements PropertySourceFactory {
    @Override
    public PropertySource<?> createPropertySource(String name, EncodedResource encodedResource)
            throws IOException {
        try {
            YamlPropertiesFactoryBean factory = new YamlPropertiesFactoryBean();
            factory.setResources(encodedResource.getResource());

            Properties properties = factory.getObject();

            return new PropertiesPropertySource(encodedResource.getResource().getFilename(), properties);
        }
        catch (final java.lang.IllegalStateException illegalState) {
            if (illegalState.getCause() instanceof final FileNotFoundException e) {
                // ConfigurationClassParser wants FileNotFoundException to honor PropertySource.ignoreResourceNotFound
                throw e;
            } else {
                throw illegalState;
            }
        }

    }
}
