package de.hsrm.sls.subato.shared.config;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.MultipartConfigElement;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;


@Component
@RestController
@Tag(name = "Querschnitt")
public class ConfigController {
    @Autowired
    MultipartConfigElement multipartConfigElement;

    @GetMapping("/config")
    @Operation(summary = "Liefert ausgewählte Konfigurationswerte, damit diese von Clients berücksichtigt werden können")
    public PublicConfig getConfig() {
        var maxFileSizeInMb = multipartConfigElement.getMaxFileSize() / 1024 / 1024;

        PublicConfig response = new PublicConfig();
        response.setMaxUploadSizeInMb(maxFileSizeInMb);
        return response;
    }
}
